//medigun.cs

//sounds
datablock AudioProfile(MedigunSound)
{
   filename    = "./MedigunShoot.wav";
   description = AudioClose3d;
   preload = true;
};

//particles
datablock ParticleData(medistreamhealParticle)
{
	dragCoefficient      = 2.9;
	gravityCoefficient   = 0.1;
	inheritedVelFactor   = 1.0;
	constantAcceleration = 0.0;
	lifetimeMS           = 1000;
	lifetimeVarianceMS   = 75;
	textureName          = "base/data/particles/dot.png";
	spinSpeed		= 10.0;
	spinRandomMin		= -50.0;
	spinRandomMax		= 50.0;
	colors[0]     = "1 0 0 1";
	colors[1]     = "1 0 0 0";
   	colors[2]     = "1 0 0 0";
   	colors[3]     = "1 0 0 0";

	sizes[0]      = 0.4;
	sizes[1]      = 0.4;
 	sizes[2]      = 0.1;
 	sizes[3]      = 0.08;

   	times[0] = 0;
   	times[1] = 1;
   	times[2] = 2;
  	times[3] = 2;

	useInvAlpha = false;
};

datablock ParticleEmitterData(medistreamhealEmitter)
{
   ejectionPeriodMS = 3;
   periodVarianceMS = 0;
   ejectionVelocity = 20;
   velocityVariance = 0.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 0;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   orientOnVelocity = false;
   particles = "medistreamhealParticle";
};


datablock ParticleData(medigunParticle)
{
   dragCoefficient      = 5.0;
   gravityCoefficient   = 0;
   inheritedVelFactor   = 0.0;
   constantAcceleration = 0.0;
   lifetimeMS           = 200;
   lifetimeVarianceMS   = 100;
   useInvAlpha          = false;
   textureName          = "./heal.png";
   colors[0]     = "1.0 0 0 1";
   colors[1]     = "1.0 0 0 1";
   colors[2]     = "1.0 0 0 1";
   sizes[0]      = 0.0;
   sizes[1]      = 0.6;
   sizes[2]      = 0.4;
   times[0]      = 0.0;
   times[1]      = 0.2;
   times[2]      = 1.0;
};

datablock ParticleEmitterData(medigunEmitter)
{
   ejectionPeriodMS = 35;
   periodVarianceMS = 0;
   ejectionVelocity = 1;
   ejectionOffset   = 1.0;
   velocityVariance = 1;
   thetaMin         = 0;
   thetaMax         = 120;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "medigunParticle";

   uiName = "medigun effect";
};

datablock ExplosionData(mediExplosion)
{
   lifeTimeMS = 128;

   particleEmitter = medigunEmitter;
   particleDensity = 2;
   particleRadius = 0.5;
   explosionScale = "0.4 0.4 0.4";
};

datablock ProjectileData(MediProjectile)
{
   directDamage        = 0;
   explosion           = MediExplosion;
   particleEmitter     = medigunEmitter;

   muzzleVelocity      = 25;
   velInheritFactor    = 1;

   armingDelay         = 0;
   lifetime            = 350;
   fadeDelay           = 0;
   bounceElasticity    = 0;
   bounceFriction      = 0;
   isBallistic         = false;
   gravityMod = 0.0;
};

datablock ShapeBaseImageData(medigunhealImage)
{
	shapeFile = "base/data/shapes/empty.dts";
	emap = false;

	mountPoint = $HeadSlot;

	stateName[0]					= "Ready";
	stateTransitionOnTimeout[0]		= "FireA";
	stateTimeoutValue[0]			= 0.01;

	stateName[1]					= "FireA";
	stateTransitionOnTimeout[1]		= "Done";
	stateWaitForTimeout[1]			= True;
	stateTimeoutValue[1]			= 0.350;
	stateEmitter[1]					= medigunEmitter;
	stateEmitterTime[1]				= 0.350;

	stateName[2]					= "Done";
	stateScript[2]					= "onDone";
};
function medigunImage::onDone(%this,%obj,%slot)
{
	%obj.unMountImage(%slot);
}

datablock ItemData(medigunItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./medigunitem.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "TF2 Medigun";
	iconName = "./icon_medigun";
	doColorShift = false;

	 // Dynamic properties defined by the scripts
	image = medigunImage;
	canDrop = true;
};

datablock ShapeBaseImageData(medigunImage)
{
   // Basic Item properties
   shapeFile = "./medigun.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = "0.4 0.55 -0.55"; //"0.7 1.2 -0.5";
   rotation = eulerToMatrix( "0 0 0" );

   className = "WeaponImage";
   item = medigunItem;
   
   // Projectile && Ammo.
   item = medigunItem;
   ammo = " ";
   projectile = mediProjectile;
   projectileType = Projectile;

   //raise your arm up or not
   armReady = true;

   doColorShift = true;
   colorShiftColor = "0.15 0.15 0.15 1.000";

   // Initial start up state
	stateName[0]                     = "Activate";
	stateTransitionOnTriggerDown[0]  = "Fire";
	stateAllowImageChange[0]	   = true;
	stateTransitionOnTimeout[0]	   = "Ready";
	stateTimeoutValue[0]		   = 0.01;
	stateSequence[0]			   = "Ready";

	stateName[1]                     = "Ready";
	stateTransitionOnTriggerDown[1]  = "StartFire";
	stateAllowImageChange[1]	   = true;

	stateName[2]                     = "Fire";
	stateTransitionOnTriggerUp[2]	   = "StopFire";
	stateTransitionOnTimeout[2]	   = "Fire";
	stateTimeoutValue[2]		   = 0.04;
	stateWaitForTimeout[2]		   = true;
	stateFire[2]			   = true;
	stateAllowImageChange[2]	   = true;
	stateScript[2]			   = "onFire";
	stateEmitter[2]			   = MediStreamhealEmitter;
	stateEmitterTime[2]		   = 0.07;

	stateName[3] 			   = "StopFire";
	stateTransitionOnTimeout[3]	   = "Ready";
	stateTimeoutValue[3]		   = 0.1;
	stateWaitForTimeout[3]		   = true;
	stateAllowImageChange[3]	   = true;
	stateSequence[3]			   = "ChargeOff";
	
		stateName[4] 			   = "StartFire";
	statesound[4]          = MedigunSound;
	stateTimeoutValue[4]		   = 0.1;
	stateTransitionOnTimeout[4]	   = "Fire";
	stateTransitionOnTriggerUp[4]	   = "StopFire";
	stateWaitForTimeout[4]		   = true;
	stateAllowImageChange[4]	   = true;
	stateSequence[4]			   = "ChargeOn";
};

  function MediProjectile::onCollision(%this,%obj,%col,%pos,%fade)
	{
		if(isObject(%col.client.minigame))
		{
			if(%obj.client.minigame $= %col.client.minigame)
			{
				if(%col.getClassName() $= "Player")
				{
					if(%col.getDamageLevel() >= 2)
					{
						%col.setDamageLevel(%col.getDamageLevel()-2);
						%obj.client.medicPoints++;
						if(%obj.client.medicPoints >= 50)
						{
							%obj.client.incScore(1);
							%obj.client.medicPoints = 0;
						}
					}
					else
					{
						%col.setDamageLevel(0);
					}
					bottomPrint(%obj.client,"\c6" @ %col.client.name @ "\'s Health = \c2" @ %col.getDatablock().maxDamage - %col.getDamageLevel() @ "/" @ %col.getDatablock().maxDamage NL "\c6Your Medic Points: \c0" @ %obj.client.MedicPoints * 2 @ "/100",1,3);
					bottomPrint(%col.client,"\c6Your Health: \c2" @ %col.getDatablock().maxDamage - %col.getDamageLevel() @ "/" @ %col.getDatablock().maxDamage NL "\c0" @ %obj.client.name SPC "\c6is healing you.",1,3);
					%col.emote(medigunhealImage);
				}
				Parent::onCollision(%this,%obj,%col,%pos,%fade);
			}
		}
	}
datablock DecalData(medigunIcon)
{
   textureName = "./icon_medigun";
};